package MIC.util;
import java.util.Collections;
import java.util.Comparator;
import java.util.Iterator;
import java.util.LinkedHashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import rescuecore2.standard.entities.*;
import rescuecore2.worldmodel.EntityID;


public class CollectionUtil {
	
    public Map<StandardEntity, Integer> MapSorter(Map<StandardEntity, Integer> unsortedMap, boolean order)
	{
		List<Entry<StandardEntity, Integer>> list = new LinkedList<Entry<StandardEntity, Integer>>(unsortedMap.entrySet());
		Collections.sort(list, new Comparator<Entry<StandardEntity, Integer>>()
		{
			
			public int compare (Entry<StandardEntity, Integer> o1,
					Entry<StandardEntity, Integer> o2)
			{
					if(order)
						return o1.getValue().compareTo(o2.getValue());
					else
						return o2.getValue().compareTo(o1.getValue());
			}
			
		}
		);
		
		Map<StandardEntity, Integer> sortedMap = new LinkedHashMap<StandardEntity, Integer>();
		for( Entry<StandardEntity, Integer> entry : list )
		{
			sortedMap.put(entry.getKey(), entry.getValue());
		}
		
		return sortedMap;
	}
    
    public List<StandardEntity> removeItemFromList(List<StandardEntity> list, StandardEntity item)
    {
    	Iterator<StandardEntity> itr = list.iterator();
    	
    	while(itr.hasNext())
    	{
			if(itr.next() == item)
				itr.remove();
    	}
       	return list;
    }


    public List<EntityID> removeItemFromList(List<EntityID> list, EntityID item)
    {
    	Iterator<EntityID> itr = list.iterator();
    	
    	while(itr.hasNext())
    	{
			if(itr.next() == item)
				itr.remove();
    	}
       	return list;
    }
    
    public List<EntityID> removeIDListFromList(List<EntityID> source, List<EntityID> deleted)
    {
    	for( int i = 0 ; i < deleted.size() ; i ++)
    	{
        	for(Iterator<EntityID> itr = source.iterator(); itr.hasNext();)	
        	{
        		if( deleted.get(i) == itr.next())
        			itr.remove();
        	}
    	}
    	return source;
    }
    
    public List<StandardEntity> removeListFromList(List<StandardEntity> source, List<StandardEntity> deleted)
    {
    	for( int i = 0 ; i < deleted.size() ; i ++)
    	{
        	for(Iterator<StandardEntity> itr = source.iterator(); itr.hasNext();)	
        	{
        		if( deleted.get(i) == itr.next())
        			itr.remove();
        	}
    	}
    	return source;
    }
    
    
}
